<script src="@#file#(webgl-math.js)" type="text/javascript"></script>
<script src="@#file#(webgl-basic.js)" type="text/javascript"></script>
<script src="@#file#(webgl-view.js)" type="text/javascript"></script>
<script src="@#file#(webgl-proj.js)" type="text/javascript"></script>
<script src="@#file#(osvj.js)" type="text/javascript"></script>

<script type="text/javascript">
  var ld3 = null;

  function start() {
    ld3 = new lightningDemo('myCanvas3');

    ld3.scene.toggleAmbient(false);
    ld3.scene.toggleDiffuze(false);
    ld3.scene.toggleSpecular(true);

    ld3.startAnimation();
  }
</script>

  <p>
    <i>Zrcalna komponenta</i> je komponenta koja modelira efekt "zasljepljivanja" promatrača koji 
    na površini vidi refleksiju izvora; ako je izvor svjetlosti visokog intenziteta, efekt može izazvati 
    vrlo neugodno blještavilo (vjerojatno se u stvarno životu opazili takvu pojavu gdje Vas je
    zasljepila refleksija sunca s nekog prozora zgrade ili automobila.
  </p>
  <p>Slika u nastavku prikazuje relevantne vektore koje treba uzeti u obzir: vektor normale ravnine \(\vec n\) te reflektirani vektor vektora od površine 
     prema izvoru \(\vec l\) koji smo označili s \(\vec r\). Primjetite da je kut između \(\vec l\) i \(\vec n\) jednak
     kutu između \(\vec n\) i \(\vec r\).</p>
  <img src="@#file#(zrcalna.svg)" alt="Izračun zrcalne komponente">
  <p>Iznos ove komponente izravno
    je ovisan o položaju na kojem se nalazi promatrač, i proporcionalan je kosinusu kuta koji svjetlost koja
    se iz izvora reflektira na površini zatvara sa spojnicom površina-promatrač. Ako se promatrač nađe izravno
    na putu reflektirane svjetlosti, efekt će biti maksimalan. Kako bi se modelirala glatkoća površine a time
    i fokusiranost ove komponente, u model se uvodi faktor <i>n</i> (engl. <i>shininess</i>) koji predstavlja potenciju
    na koju se diže spomenuti kosinus kuta. Radi se o pozitivnom broju uobičajenog raspona od 1 na više (primjerice do 128),
    pri čemu manji broj označava manje glatku površinu pa će efekt biti manje fokusiran.
  </p>

  <p>
  \[
    I_{r} \propto cos ^n (\vec r,  \vec v)
  \]
  </p>

  <p><i>Važno</i>: ova komponenta postoji samo ako je izvor iznad površine, odnosno ako je kut između vektora od površine
     do izvora i vektora normale površine između 0 i 90°.</p>

  <p>Demonstracija u nastavku prikazuje utjecaj zrcalne komponente.</p>

  <p>Kontrolom prikazanom ispod demonstracije možete isključiti zrcalnu komponentu: scena će time postati potpuno crna.
     Dodatno, možete kontrolirati iznos faktora <i>n</i> koji se koristi pri izračunu ove komponente osvjetljenja - isprobajte što se
     događa kada ga mijenjate.</p>

  <canvas id="myCanvas3" width="640" height="480">
    Your browser doesn't appear to support the 
    &lt;canvas&gt; element.
  </canvas>
  <p>
  <input type="checkbox" checked onchange="ld3.scene.toggleSpecular(this.checked);"> Zrcalna komponenta <br>
  1 <input style="width: 200px; display: inline;" type="range" min="1" max="50" step="1" oninput="ld3.scene.shininess=this.value;" onchange="ld3.scene.shininess=this.value;" value="20"> 50<br>
  </p>

  <p>
    Primjetite da je odbljesak bijele boje jer je izvor u sceni izvor bijele svjetlosti - unatoč tome što
    su same kugle crvene odnosno zelene boje. Odbljesak je najčešće boje izvora i ne ovisi previše o boji materijala objekta.
  </p>

<script type="text/javascript">
start();
</script>

